step_poly {recipes} | R Documentation

## Orthogonal Polynomial Basis Functions

### Description

`step_poly` creates a specification of a recipe step that will create new columns that are basis expansions of variables using orthogonal polynomials.

### Usage

    step_poly(recipe, ..., role = "predictor", trained = FALSE,
      objects = NULL, options = list(degree = 2), skip = FALSE,
      id = rand_id("poly"))

    ## S3 method for class 'step_poly'
    tidy(x, ...)

### Arguments

`recipe` | A recipe object. The step will be added to the sequence of operations for this recipe.
`...` | One or more selector functions to choose which variables are affected by the step. See `selections()` for more details. For the `tidy` method, these are not currently used.
`role` | For model terms created by this step, what analysis role should they be assigned?. By default, the function assumes that the new columns created from the original variables will be used as predictors in a model.
`trained` | A logical to indicate if the quantities for preprocessing have been estimated.
`objects` | A list of `stats::poly()` objects created once the step has been trained.
`options` | A list of options for `stats::poly()` which should not include `x` or `simple`. Note that the option `raw = TRUE` will produce the regular polynomial values (not orthogonalized).
`skip` | A logical. Should the step be skipped when the recipe is baked by `bake.recipe()`? While all operations are baked when `prep.recipe()` is run, some operations may not be able to be conducted on new data (e.g. processing the outcome variable(s)). Care should be taken when using `skip = TRUE` as it may affect the computations for subsequent operations
`id` | A character string that is unique to this step to identify it.
`x` | A `step_poly` object.

### Details

`step_poly` can new features from a single variable that enable fitting routines to model this variable in a nonlinear manner. The extent of the possible nonlinearity is determined by the `degree` argument of `stats::poly()`. The original variables are removed from the data and new columns are added. The naming convention for the new variables is `varname_poly_1` and so on.

### Value

An updated version of `recipe` with the new step added to the sequence of existing steps (if any). For the `tidy` method, a tibble with columns `terms` (the columns that will be affected) and `degree`.

### See Also

`step_ns()` `recipe()` `prep.recipe()` `bake.recipe()`

### Examples

    data(biomass)

    biomass_tr <- biomass[biomass$dataset == "Training",]
    biomass_te <- biomass[biomass$dataset == "Testing",]

    rec <- recipe(HHV ~ carbon + hydrogen + oxygen + nitrogen + sulfur,
                  data = biomass_tr)

    quadratic <- rec %>%
      step_poly(carbon, hydrogen)
    quadratic <- prep(quadratic, training = biomass_tr)

    expanded <- bake(quadratic, biomass_te)
    expanded

    tidy(quadratic, number = 1)

[Package recipes version 0.1.5 Index]